unit _ip;

interface

//uses Math, SysUtils, StdCtrls, Classes, TreeFunc, ComCtrls, Controls, DB, Mask;

uses SysUtils, {$IFDEF WIN32} Windows, {$ELSE} WinTypes, WinProcs, {$ENDIF}
  Math, Messages,StrUtils, Classes, Graphics, Controls, Menus, Forms, StdCtrls,
  Mask, ComCtrls,db;

{INFOPLUS routines}

   //String operations
   function LeftS(S:String;n:integer):String;
   function RightS(S:String;n:integer):String;
   function MakeS(C:Char;FDecimals:integer):String;
   //Rounding
   function RoundFF(AValue:extended;FDecimals:integer):extended;
   function RoundFS(AValue:extended;FDecimals:integer;characters:integer):string;
   function TextToValText(const AValue: string): string;
   function RoundSF(AValue:String;FDecimals:integer):extended;
   function StrToValue(AValue:string):Extended;
   function FloatToInt(AValue:Extended):integer;
   //Other
   procedure ReOpen(DataSet:TDataset);
   procedure DoEdit(DataSet:TDataset);
   function AppDir:string;
   
implementation


function LeftS(S:String;n:integer):String;
var
len:integer;
begin
len:=Length(S);
if n<0 then n:=0;
if n>len then n:=len;
LeftS:=Copy(S,1,n);
end;

function RightS(S:String;n:integer):String;
var
len:integer;
begin
len:=Length(S);
if n<0 then n:=0;
if n>len then n:=len;
RightS:=Copy(S,len-n+1,n);
end;

function MakeS(C:Char;FDecimals:integer):String;
var
   i:integer;
begin
//StringOfChar(C, FDecimals)
   Result:='';
   for i:=1 to FDecimals do
       Result:=Result+C;
end;

function StrToValue(AValue:string):Extended;
var
   S:string;
begin
   S:=AValue;
   S:=TextToValText(S);
   Result:=StrToFloat(S);
end;

function TextToValText(const AValue: string): string;
begin
  Result := DelRSpace(AValue);
  if DecimalSeparator <> ThousandSeparator then
    Result := DelChars(Result, ThousandSeparator);
  if Result = '' then Result := '0'
  else if Result = '-' then Result := '-0';
end;

function RoundSF(AValue:String;FDecimals:integer):extended;
var
   FormatMask : string;
   Number:extended;
   S:String;
begin
   Number:=StrToValue(AValue);
  if FDecimals = 0 then
     FormatMask := '0'
  else
     FormatMask := '0.'+StringOfChar('0', FDecimals);
      S:= FormatFloat(FormatMask, Number);
   Result:=StrToFloat(S);
end;

function RoundFF(AValue:extended;FDecimals:integer):extended;
var
   FormatMask,S : string;
begin
  if FDecimals = 0 then
     FormatMask := '0'
  else
     FormatMask := '0.'+StringOfChar('0', FDecimals);
      S := FormatFloat(FormatMask, AValue);
     Result:=StrToFloat(S);
  end;

function RoundFS(AValue:extended;FDecimals:integer;Characters:integer):string;
var
   FormatMask,S : string;
begin
  //if FDecimals = 0 then
   //  FormatMask := ',0'
 // else
     FormatMask :=',0.'+StringOfChar('0', FDecimals);
  S := FormatFloat(FormatMask, AValue);
  Result:=S;
   if (Characters>0) and (Characters<>Length(S)) then
   begin
       if Length(S)>Characters then
           Result:=MakeS('#',Characters)
       else if Length(S)<Characters then
           Result:=MakeS(' ',Characters-Length(S))+S;
   end;
end;

function FloatToInt(AValue:Extended):integer;
begin
    Result:=Round(AValue);
end;

procedure ReOpen(DataSet:TDataset);
begin
   DataSet.Close;
   DataSet.Open;
end;

procedure DoEdit(DataSet:TDataset);
begin
    if DataSet.State=dsBrowse then
        DataSet.Edit
end;


function AppDir:string;
begin
   Result:=ExtractFileDir(Application.ExeName);
end;

end.
